function ese4
% u''(x)=cos(u(x))
% u(0)=0
% u(1)=0
% differenze finite
a = 0;
b = 1;
m = 100;
x = linspace(a,b,m)';
h = (b-a)/(m-1);
A = toeplitz(sparse([1,1],[1,2],[-2,1]/h^2,1,m));
u0 = linspace(0,1,m)';
tol = 1e-12;
u = newton(@(u)F(u,A,h),@(u)J(u,A,h),u0,6,tol);
plot(x,u)

function f = F(u,A,h)
m = length(u);
f = A*u-cos(u);
f(1) = u(1)/h^2;
f(m) = (u(m)-1)/h^2;

function j = J(u,A,h)
m = length(u);
j = A+spdiags(sin(u),0,m,m);
j(1,1) = 1/h^2;
j(1,2) = 0;
j(m,m-1) = 0;
j(m,m) = 1/h^2;

function u = newton(F,J,u0,maxiter,tol)
u = u0;
errest = -J(u)\F(u);
iter = 1;
while (norm(errest,inf) > tol && iter <= maxiter)
  u = u+errest;
  errest = -J(u)\F(u);
  iter = iter+1;
end
if (errest > tol)
  warning('Raggiunto il numero massimo di iterazioni')
end